# Generated by sila2.code_generator; sila2.__version__: 0.12.2
from __future__ import annotations

from abc import ABC, abstractmethod
from datetime import timedelta
from typing import TYPE_CHECKING, List, Optional

from sila2.server import FeatureImplementationBase, MetadataDict, ObservableCommandInstance

from .dataaggregatorcontroller_types import (
    AggregateData_Responses,
    SetAutoAggregation_Responses,
    SetStandardAggregationDataFormat_Responses,
)

if TYPE_CHECKING:
    from ...server import Server


class DataAggregatorControllerBase(FeatureImplementationBase, ABC):
    parent_server: Server

    AggregateData_default_lifetime_of_execution: Optional[timedelta]

    def __init__(self, parent_server: Server):
        """
        The Data Aggregator Controller
        """
        super().__init__(parent_server=parent_server)

        self.AggregateData_default_lifetime_of_execution = None

    @abstractmethod
    def get_DataOutputFormats(self, *, metadata: MetadataDict) -> List[str]:
        """
        Supported Data Output Formats

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Supported Data Output Formats
        """

    @abstractmethod
    def get_AutoMeasurementTypes(self, *, metadata: MetadataDict) -> List[str]:
        """
        List all Auto Measurement Types

        :param metadata: The SiLA Client Metadata attached to the call
        :return: List all Auto Measurement Types
        """

    @abstractmethod
    def SetStandardAggregationDataFormat(
        self, DataFormat: str, *, metadata: MetadataDict
    ) -> SetStandardAggregationDataFormat_Responses:
        """
        Sets the standard Aggregation Data Format


        :param DataFormat: Data Format

        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def SetAutoAggregation(self, AutoAggregate: bool, *, metadata: MetadataDict) -> SetAutoAggregation_Responses:
        """
        The LabDataAggregator comes with a default Aggregation Configuration and default Feature Calls. Set Auto Aggregation of all known (default) measurement types.


        :param AutoAggregate: Auto Aggregate

        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def AggregateData(
        self,
        Bucket: str,
        Measurement: str,
        Factor: str,
        Device: str,
        StartTime: str,
        EndTime: str,
        DataFormat: str,
        AggregationInterval: float,
        *,
        metadata: MetadataDict,
        instance: ObservableCommandInstance,
    ) -> AggregateData_Responses:
        """
        Initiate Data Aggregation


        :param Bucket: Name of the InfluxDB Bucket

        :param Measurement: Name of the InfluxDB Measurement

        :param Factor: Factor or Category (=Field in InfluxDB), which is used to aggregate the data

        :param Device: Device Name

        :param StartTime: Start Time of the Aggregation. String in ISO 8601 format, e.g. 2007-12-23T18:21:33Z. It is also possible to provide a time difference, e.g. -42m = the last 42 minutes.

        :param EndTime: End Time of the Aggregation. String in ISO 8601 format, e.g. 2007-12-23T18:21:33Z. If empty, the current time is assumed.

        :param DataFormat: Data output format of the aggregated data

        :param AggregationInterval: Aggregation Interval in seconds (Real).

        :param metadata: The SiLA Client Metadata attached to the call
        :param instance: The command instance, enabling sending status updates to subscribed clients

        :return:

            - AggregatedValues: Aggregated Values in serialised string format. In case of SCIDATS format, the data is serialised as BASE64 encoded string.



        """
